// C Header File
// Created 9/3/2002; 5:29:38 PM

#ifndef GRAPHX_H
#define GRAPHX_H

#include "extgraph.h"

#define DrawSnakeHead(x, y, dir) GraySprite8_MASK((x), (y), 5, snakeHead+(5*(dir)), snakeHead+20, snakeMask, snakeMask, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE))
#define DrawSnakeBody(x, y, dir) GraySprite8_MASK((x), (y), 5, snakeBody+((dir & 1) ? 10 : 0), snakeBody+((dir & 1) ? 15 : 5), snakeMask, snakeMask, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE))
#define DrawSnakeTail(x, y, dir) GraySprite8_MASK((x), (y), 5, snakeTail+(10*(dir)), snakeTail+(10*(dir))+5, snakeMask, snakeMask, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE))
#define DrawSnakeCurve(x, y, dir) GraySprite8_MASK((x), (y), 5, snakeCurve+(10*(dir)), snakeCurve+(10*(dir))+5, snakeMask, snakeMask, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE))
//#define DrawObstacle(x, y) GraySprite8_MASK((x), (y), 5, Obstacle, Obstacle+5, snakeMask, snakeMask, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE))
#define DrawBlackObst(x, y, type) Sprite8_XOR((x), (y), 5, MultiObst+(10*(type)), LCD_MEM);
#define DrawMultiObst(x, y, type) GraySprite8_MASK((x), (y), 5, MultiObst+(10*(type)), MultiObst+(10*(type))+5, snakeMask, snakeMask, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE))
#define DrawApple(x, y) GraySprite8_MASK((x), (y), 5, Apple, Apple+5, snakeMask, snakeMask, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE))
//#define DrawNum(x, y, num) GraySprite8_BLIT((x), (y), 8, Font+((num)*16), Font+((num)*16)+8, 0, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE))
#define DrawNum(x, y, num) drawChar((x), (y), num, TEXT_OR | TEXT_BLACK)
#define DrawLive(x, y) GraySprite8_BLIT((x), (y), 5, HUDgraphics, HUDgraphics+5, 0, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE))
#define DrawInfinity(x, y) GraySprite16_OR((x), (y), 8, Infinity, Infinity, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE))
#define XorArrow(x, y, dir) GraySprite8_XOR((x), (y), 5, MenuGraphics+(10*(dir)), MenuGraphics+(10*(dir))+5, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE))
#define XorMouse(x, y) GraySprite8_XOR((x), (y), 8, Mouse, Mouse, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE))
#define EraseFont(x, y) GraySprite8_AND((x), (y), 8, erase8, erase8, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE))
#define EraseSnake(x, y) GraySprite8_AND((x), (y), 5, snakeMask, snakeMask, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE))
#define EraseArrow(x, y) EraseSnake((x), (y))

static unsigned char snakeMask[5] = {
	0x07, //00000111
	0x07, //00000111
	0x07, //00000111
	0x07, //00000111
	0x07  //00000111
};

static unsigned char erase8[8] = {
	0x00, //00000000
	0x00, //00000000
	0x00, //00000000
	0x00, //00000000
	0x00, //00000000
	0x00, //00000000
	0x00, //00000000
	0x00  //00000000
};

static unsigned char snakeHead[25] = {
	//south
		0x70,  //01110---
		0xF8,  //11111---
		0xA8,  //10101---
		0xA8,  //10101---
		0x70,  //01110---
	
	//west
		0x70,  //01110---
		0x98,  //10011---
		0xF8,  //11111---
		0x98,  //10011---
		0x70,  //01110---
	
	//north
		0x70,  //01110---
		0xA8,  //10101---
		0xA8,  //10101---
		0xF8,  //11111---
		0x70,  //01110---
	
	//east
		0x70,  //01110---
		0xC8,  //11001---
		0xF8,  //11111---
		0xC8,  //11001---
		0x70,  //01110---
	
	//light gray
		0x88,  //10001---
		0x00,  //00000---
		0x00,  //00000---
		0x00,  //00000---
		0x88   //10001---
};

static unsigned char snakeBody[20] = {
	//vertical
		0x70,  //01110---
		0x60,  //01100---
		0x38,  //00111---
		0xF0,  //11110---
		0x40,  //01000---
		
		0x80,  //01000---
		0x38,  //00111---
		0xF8,  //11111---
		0xC0,  //11000---
		0x30,  //00110---
	
	//horizontal
		0x40,  //01000---
		0xD8,  //11011---
		0x78,  //01111---
		0x68,  //01101---
		0x20,  //00100---
		
		0x60,  //01100---
		0x68,  //01101---
		0xB0,  //10110---
		0xB0,  //10110---
		0x30   //00110---
};

static unsigned char snakeCurve[40] = {
	//S to W   E to N
		0x70, //01110---
		0xC0, //11000---
		0x60, //01100---
		0x40, //01000---
		0x00, //00000---
		
		0x40, //01000---
		0x70, //01110---
		0xB0, //10110---
		0xA0, //10100---
		0x00, //00000---
	
	//W to N   S to E
		0x10, //00010---
		0x78, //01111---
		0x28, //00101---
		0x08, //00001---
		0x00, //00000---
		
		0x60, //01100---
		0x18, //00011---
		0x70, //01110---
		0x30, //00110---
		0x00, //00000---
	
	//N to E   W to S
		0x00, //00000---
		0x10, //00010---
		0x30, //00110---
		0x18, //00011---
		0x70, //01110---
		
		0x00, //00000---
		0x28, //00101---
		0x68, //01101---
		0x70, //01110---
		0x10, //00010---
	
	//E to S   N to W
		0x00, //00000---
		0x80, //10000---
		0xA0, //10100---
		0xF0, //11110---
		0x40, //01000---
		
		0x00, //00000---
		0x60, //01100---
		0x70, //01110---
		0xC0, //11000---
		0x30  //00110---
};

static unsigned char snakeTail[40] = {
	//south
		0x00,  //00000---
		0x70,  //01110---
		0x70,  //01110---
		0xF8,  //11111---
		0xF8,  //11111---
		
		0x20,  //00100---
		0x20,  //00100---
		0x88,  //10001---
		0x38,  //00111---
		0xC0,  //11000---
	
	//west
		0xC0,  //11000---
		0xF0,  //11110---
		0xF0,  //11110---
		0xF0,  //11110---
		0xC0,  //11000---
		
		0xA0,  //10100---
		0x80,  //10000---
		0x58,  //01011---
		0x40,  //01000---
		0x60,  //01100---
	
	//north
		0xF8,  //11111---
		0xF8,  //11111---
		0x70,  //01110---
		0x70,  //01110---
		0x00,  //00000---
		
		0xC0,  //11000---
		0x38,  //00111---
		0x88,  //10001---
		0x20,  //00100---
		0x20,   //00100---
	
	//east
		0x18,  //00011---
		0x78,  //01111---
		0x78,  //01111---
		0x78,  //01111---
		0x18,  //00011---
		
		0x28,  //00101---
		0x08,  //00001---
		0xD0,  //11010---
		0x10,  //00010---
		0x30   //00110---
};

/*static unsigned char Obstacle[] = {
	//dark
	0xA8, //10101---
	0xA8, //10101---
	0xF8, //11111---
	0x70, //01110---
	0x70, //01110---
	//light
	0x00, //00000---
	0xF8, //11111---
	0x70, //01110---
	0x70, //01110---
	0xF8  //11111---
};*/

static unsigned char MultiObst[] = {
	//SWNE
	//0000
	//dark
	0x70, //01110---
	0x88, //10001---
	0x88, //10001---
	0x88, //10001---
	0x70, //01110---
	//light
	0xA8, //10101---
	0x50, //01010---
	0x88, //10001---
	0x50, //01010---
	0xA8, //10101---
	
	//0001
	//dark
	0x78, //01111---
	0xC0, //11000---
	0x80, //10000---
	0xC0, //11000---
	0x78, //01111---
	//light
	0x18, //00011---
	0x20, //00100---
	0x80, //10000---
	0x20, //00100---
	0x18, //00011---
	
	//0010
	//dark
	0x88, //10001---
	0x88, //10001---
	0x88, //10001---
	0xD8, //11011---
	0x70, //01110---
	//light
	0x88, //10001---
	0x88, //10001---
	0x50, //01010---
	0x00, //00000---
	0x20, //00100---
	
	//0011
	//dark
	0x88, //10001---
	0x80, //10000---
	0x80, //10000---
	0x40, //01000---
	0x38, //00111---
	//light
	0x80, //10000---
	0x80, //10000---
	0x40, //01000---
	0xE0, //11100---
	0x58, //01011---
	
	//0100
	//dark
	0xF0, //11110---
	0x18, //00011---
	0x08, //00001---
	0x18, //00011---
	0xF0, //11110---
	//light
	0xC0, //11000---
	0x20, //00100---
	0x08, //00001---
	0x20, //00100---
	0xC0, //11000---
	
	//0101
	//dark
	0xF8, //11111---
	0x00, //00000---
	0x00, //00000---
	0x00, //00000---
	0xF8, //11111---
	//light
	0xD8, //11011---
	0x70, //01110---
	0x00, //00000---
	0x70, //01110---
	0xD8, //11011---
	
	//0110
	//dark
	0x88, //10001---
	0x08, //00001---
	0x08, //00001---
	0x10, //00010---
	0xE0, //11100---
	//light
	0x08, //00001---
	0x08, //00001---
	0x10, //00010---
	0x38, //00111---
	0xD0, //11010---
	
	//0111
	//dark
	0x88, //10001---
	0x00, //00000---
	0x00, //00000---
	0x00, //00000---
	0xF8, //11111---
	//light
	0x50, //01010---
	0x88, //10001---
	0x00, //00000---
	0x00, //00000---
	0xF8, //11111---
	
	//1000
	//dark
	0x70, //01110---
	0xD8, //11011---
	0x88, //10001---
	0x88, //10001---
	0x88, //10001---
	//light
	0x20, //00100---
	0x00, //00000---
	0x50, //01010---
	0x88, //10001---
	0x88, //10001---
	
	//1001
	//dark
	0x38, //00111---
	0x40, //01000---
	0x80, //10000---
	0x80, //10000---
	0x88, //10001---
	//light
	0x58, //01011---
	0xE0, //11100---
	0x40, //01000---
	0x80, //10000---
	0x80, //10000---
	
	//1010
	//dark
	0x88, //10001---
	0x88, //10001---
	0x88, //10001---
	0x88, //10001---
	0x88, //10001---
	//light
	0x88, //10001---
	0xD8, //11011---
	0x50, //01010---
	0xD8, //11011---
	0x88, //10001---
	
	//1011
	//dark
	0x88, //10001---
	0x80, //10000---
	0x80, //00000---
	0x80, //10000---
	0x88, //10001---
	//light
	0x90, //10010---
	0xC8, //11001---
	0x40, //01000---
	0xC8, //11001---
	0x90, //10010---
	
	//1100
	//dark
	0xE0, //11100---
	0x10, //00010---
	0x08, //00001---
	0x08, //00001---
	0x88, //10001---
	//light
	0xD0, //11010---
	0x38, //00111---
	0x10, //00010---
	0x08, //00001---
	0x08, //00001---
	
	//1101
	//dark
	0xF8, //11111---
	0x00, //00000---
	0x00, //00000---
	0x00, //00000---
	0x88, //10001---
	//light
	0xD8, //11011---
	0x70, //01110---
	0x00, //00000---
	0x88, //10001---
	0x50, //01010---
	
	//1110
	//dark
	0x88, //10001---
	0x08, //00001---
	0x08, //00001---
	0x08, //00001---
	0x88, //10001---
	//light
	0x48, //01001---
	0x98, //10011---
	0x10, //00010---
	0x98, //10011---
	0x48, //01001---
	
	//1111
	//dark
	0x00, //00000---
	0x00, //00000---
	0x00, //00000---
	0x00, //00000---
	0x00, //00000---
	//light
	0x00, //00000---
	0x00, //00000---
	0x00, //00000---
	0x00, //00000---
	0x00, //00000---
};

static unsigned char Apple[] = {
	//dark
	0x18, //00011---
	0x50, //01010---
	0xE8, //11101---
	0xE8, //11101---
	0x70, //01110---
	//light
	0x20, //00100---
	0x20, //00100---
	0x70, //01110---
	0x70, //01110---
	0x00  //00000---
};

static unsigned long Level[] = {
	//dark
	//               1   1   1   1   1   1   1   1
	0x00000040, //00000000000000000000000001000000
	0x00003840, //00000000000000000011100001000000
	0x80012440, //10000000000000010010010001000000
	0x83891C60, //10000011100010010001110001100000
	0x82491020, //10000010010010010001000000100000
	0x81C70E20, //10000001110001110000111000100000
	0x81020000, //10000001000000100000000000000000
	0xD8E00000, //11011000111000000000000000000000
	0x70000000, //01110000000000000000000000000000
	
	//light
	//               1   1   1   1   1   1   1   1
	0x00000040, //00000000000000000000000001000000
	0x00001C40, //00000000000000000001110001000000
	0x00012460, //00000000000000010010010001100000
	0x81C93C20, //10000001110010010011110000100000
	0x82493120, //10000010010010010011000100100000
	0xC3CC1E20, //11000011110011000001111000100000
	0xC3060020, //11000011000001100000000000100000
	0x79F00000, //01111001111100000000000000000000
	0xE0000000  //11100000000000000000000000000000
};

static unsigned char Complete[] = {
	//dark
	0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, //00000000 00000000 00000000 00000010 00000000 00000000 00000000
	0x3E, 0x00, 0x00, 0x02, 0x00, 0x80, 0x00, //00111110 00000000 00000000 00000010 00000000 10000000 00000000
	0x62, 0x00, 0x01, 0x02, 0x00, 0x53, 0x80, //01100010 00000000 00000001 00000010 00000000 01010011 10000000
	0xC2, 0x00, 0x94, 0xE2, 0x1B, 0xE4, 0x80, //11000010 00000000 10011100 11100010 00011101 11100100 10000000
	0x80, 0x0E, 0xB4, 0x93, 0x24, 0x47, 0x00, //10000000 00001110 10110100 10010011 00100100 01000111 00000000
	0x80, 0x12, 0xD4, 0x91, 0x38, 0x44, 0x00, //10000000 00010010 11010100 10010001 00111000 01000100 00000000
	0x80, 0x22, 0x54, 0x91, 0x20, 0x24, 0x00, //10000000 00100010 01010100 10010001 00100000 00100100 00000000
	0xC0, 0x22, 0x44, 0xB1, 0x1C, 0x23, 0x80, //11000000 00100010 01000100 10110001 00011100 00100011 10000000
	0x61, 0x22, 0x48, 0x80, 0x00, 0x00, 0x00, //01100001 00100010 01001000 10000000 00000000 00000000 00000000
	0x3F, 0x3C, 0x08, 0x80, 0x00, 0x00, 0x00, //00111111 00111100 00001000 10000000 00000000 00000000 00000000
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, //00000000 00000000 00000000 00000000 00000000 00000000 00000000
	
	//light
	0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, //00000000 00000000 00000000 00000010 00000000 00000000 00000000
	0x7E, 0x00, 0x00, 0x02, 0x00, 0x60, 0x00, //01111110 00000000 00000000 00000010 00000000 11000000 00000000
	0xC6, 0x00, 0x00, 0x02, 0x00, 0x57, 0x80, //11000110 00000000 00000000 00000010 00000000 01010111 10000000
	0x80, 0x00, 0x3C, 0xF3, 0x39, 0xF4, 0x80, //10000000 00000000 00111100 11110011 00111001 11110100 10000000
	0x80, 0x1C, 0xF4, 0x91, 0x24, 0x47, 0x80, //10000000 00011100 11110100 10010001 00100100 01000111 10000000
	0x80, 0x32, 0xD4, 0x91, 0x38, 0x24, 0x00, //10000000 00110010 11010100 10010001 00111000 00100100 00000000
	0x80, 0x22, 0x54, 0x91, 0x22, 0x26, 0x00, //10000000 00100010 01010100 10010001 00100010 00100110 00000000
	0x80, 0x22, 0x44, 0xF1, 0x3C, 0x23, 0xC0, //10000000 00100010 01000100 11110001 00111100 00100011 11000000
	0xC2, 0x22, 0x4C, 0x81, 0x00, 0x00, 0x00, //11000010 00100010 01001100 10000001 00000000 00000000 00000000
	0x7F, 0x1E, 0x08, 0x80, 0x00, 0x00, 0x00, //01111111 00011110 00001000 10000000 00000000 00000000 00000000
	0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00  //00000000 00000000 00000000 10000000 00000000 00000000 00000000
};

/*static unsigned char HUDgraphics[] = {
	//lives
	//dark
	0x00, //00000---
	0x50, //01010---
	0x00, //00000---
	0x88, //10001---
	0x70, //01110---
	
	//light
	0x50, //01010---
	0x50, //01010---
	0x00, //00000---
	0x00, //00000---
	0x70, //01110---
	
	//heart
	//dark
	0x50, //01010---
	0xA8, //10101---
	0x88, //10001---
	0x50, //01010---
	0x20, //00100---
	
	//light
	0x70, //01110---
	0x00, //00000---
	0x88, //10001---
	0x88, //10001---
	0x50, //01010---
};*/

static unsigned char MenuGraphics[] = {
	//down arrow
	//dark
	0x70, //01110---
	0x70, //01110---
	0x70, //01110---
	0x70, //01110---
	0x20, //00100---
	//light
	0x20, //00100---
	0x20, //00100---
	0xF8, //11111---
	0x20, //00100---
	0x00, //00000---
	
	//left arrow
	//dark
	0x00, //00000---
	0x78, //01111---
	0xF8, //11111---
	0x78, //01111---
	0x00, //00000---
	//light
	0x20, //00100---
	0x20, //00100---
	0x78, //01111---
	0x20, //00100---
	0x20, //00100---
	
	//up arrow
	//dark
	0x20, //00100---
	0x70, //01110---
	0x70, //01110---
	0x70, //01110---
	0x70, //01110---
	//light
	0x00, //00000---
	0x20, //00100---
	0xF8, //11111---
	0x20, //00100---
	0x20, //00100---
	
	//right arrow
	//dark
	0x00, //00000---
	0xF0, //11110---
	0xF8, //11111---
	0xF0, //11110---
	0x00, //00000---
	//light
	0x20, //00100---
	0x20, //00100---
	0xF0, //11110---
	0x20, //00100---
	0x20, //00100---
};

static unsigned char Font[] = {
	//0
	0x3C, //00111100
	0x42, //01000010
	0x9A, //10011010
	0xAA, //10101010
	0xAA, //10101010
	0xB2, //10110010
	0x84, //10000100
	0x78, //01111000
	
	//1
	0x1C, //00011100
	0x24, //00100100
	0x74, //01110100
	0x14, //00010100
	0x14, //00010100
	0x36, //00110110
	0x42, //01000010
	0x7C, //01111100
	
	//2
	0x78, //01111000
	0x84, //10000100
	0xB4, //10110100
	0xD4, //11010100
	0x2C, //00101100
	0x5A, //01011010
	0x82, //10000010
	0xFC, //11111100
	
	//3
	0x3C, //00111100
	0x42, //01000010
	0x32, //00110010
	0x24, //00100100
	0x12, //00010010
	0x72, //01110010
	0x84, //10000100
	0x78, //01111000
	
	//4
	0x34, //00110100
	0x2A, //00101010
	0x5A, //01011010
	0x42, //01000010
	0x3A, //00111010
	0x0A, //00001010
	0x0A, //00001010
	0x04, //00000100
	
	//5
	0x3C, //00111100
	0x42, //01000010
	0x5C, //01011100
	0x42, //01000010
	0x4A, //01011010
	0x72, //01110010
	0x84, //10000100
	0x78, //01111000
	
	//6
	0x1C, //00011100
	0x24, //00100100
	0x48, //01001000
	0x58, //01011000
	0x44, //01000100
	0x52, //01010010
	0x42, //01000010
	0x3C, //00111100
	
	//7
	0x3C, //00111100
	0x42, //01000010
	0x7A, //01111010
	0x0A, //00001010
	0x14, //00010100
	0x28, //00101000
	0x50, //01010000
	0x60, //01100000
	
	//8
	0x1C, //00011100
	0x22, //00100010
	0x2A, //00101010
	0x22, //00100010
	0x44, //01000100
	0x54, //01010100
	0x44, //01000100
	0x38, //00111000
	
	//9
	0x38, //00111000
	0x44, //01000100
	0x54, //01010100
	0x44, //01000100
	0x34, //00110100
	0x24, //00100100
	0x48, //01001000
	0x70, //01110000
	
	//A 10
	0x0E, //00001110
	0x12, //00010010
	0x12, //00010010
	0x21, //00100001
	0x41, //01000001
	0x5D, //01011101
	0x95, //10010101
	0xE6, //11100110
	
	//B 11
	0x3C, //00111100
	0x22, //00100010
	0x22, //00100010
	0x44, //01000100
	0x42, //01000010
	0x42, //01000010
	0x84, //10000100
	0xF8, //11111000
	
	//C 12
	0x3C, //00111100
	0x42, //01000010
	0x5A, //01011010
	0x94, //10010100
	0xA0, //10100000
	0x9C, //10011100
	0x42, //01000010
	0x3C, //00111100
	
	//D 13
	0x3C, //00111100
	0x22, //00100010
	0x29, //00101001
	0x55, //01010101
	0x55, //01010101
	0x5A, //01011010
	0x84, //10000100
	0xF8, //11111000
	
	//E 14
	0x3E, //00111110
	0x21, //00100001
	0x2D, //00101101
	0x46, //01000110
	0x58, //01011000
	0x5C, //01011100
	0x82, //10000010
	0xFC, //11111100
	
	//F 15
	0x3E, //00111110
	0x21, //00100001
	0x2D, //00101101
	0x53, //01010011
	0x48, //01001000
	0x58, //01011000
	0xA0, //10100000
	0xE0, //11100000
	
	//G 16
	0x3C, //00111100
	0x42, //01000010
	0x5E, //01011110
	0xA0, //10100000
	0xAC, //10101100
	0x9A, //10011010
	0x42, //01000010
	0x3E, //00111110
	
	//H 17
	0x66, //01100110
	0x55, //01010101
	0x55, //01010101
	0xBD, //10111101
	0x82, //10000010
	0xBA, //10111010
	0xAA, //10101010
	0xCC, //11001100
	
	//I 18
	0x7F, //01111111
	0x81, //10000001
	0xF6, //11110110
	0x14, //00010100
	0x14, //00010100
	0x67, //01100111
	0x81, //10000001
	0xFE, //11111110
	
	//J 19
	0x7F, //01111111
	0x81, //10000001
	0xF3, //11110011
	0x14, //00010100
	0xD4, //11010100
	0xB4, //10110100
	0x88, //10001000
	0x70, //01110000
	
	//K 20
	0x63, //01100011
	0xAD, //10101101
	0xB2, //10110010
	0x8C, //10001100
	0xA8, //10101000
	0xA4, //10100100
	0xB2, //10110010
	0xCE, //11001110
	
	//L 21
	0x30, //00110000
	0x50, //01010000
	0x50, //01010000
	0x50, //01010000
	0xA0, //10100000
	0xBC, //10111100
	0x82, //10000010
	0xFE, //11111110
	
	//M 22
	0x33, //00110011
	0x4D, //01001101
	0x41, //01000001
	0x51, //01010001
	0x95, //10010101
	0xBD, //10111101
	0xA5, //10100101
	0xC6, //11000110
	
	//N 23
	0x23, //00100011
	0x55, //01010101
	0x4D, //01001101
	0x45, //01000101
	0x91, //10010001
	0xAA, //10101010
	0xAA, //10101010
	0xC4, //11000100
	
	//O 24
	0x38, //00111000
	0x44, //01000100
	0x52, //01010010
	0xAA, //10101010
	0xAA, //10101010
	0x94, //10010100
	0x44, //01000100
	0x38, //00111000
	
	//P 25
	0x3C, //00111100
	0x42, //01000010
	0x5A, //01011010
	0x44, //01000100
	0xB8, //10111000
	0xA0, //10100000
	0xA0, //10100000
	0xC0, //11000000
	
	//Q 26
	0x38, //00111000
	0x44, //01000100
	0xB2, //10110010
	0xAA, //10101010
	0xAA, //10101010
	0x92, //10010010
	0x49, //01001001
	0x3F, //00111111
	
	//R 27
	0x3E, //00111110
	0x41, //01000001
	0x59, //01011001
	0x42, //01000010
	0x9A, //10011010
	0xA9, //10101001
	0xA5, //10100101
	0xC3, //11000011
	
	//S 28
	0x3E, //00111110
	0x41, //01000001
	0x4E, //01001110
	0x44, //01000100
	0x22, //00100010
	0x72, //01110010
	0x82, //10000010
	0x7C, //01111100
	
	//T 29
	0x7F, //01111111
	0x81, //10000001
	0xF7, //11110111
	0x14, //00010100
	0x14, //00010100
	0x28, //00101000
	0x28, //00101000
	0x30, //00110000
	
	//U 30
	0x62, //01100010
	0xA5, //10100101
	0xA5, //10100101
	0xA5, //10100101
	0xA9, //10101001
	0x9A, //10011010
	0x42, //01000010
	0x3C, //00111100
	
	//V 31
	0xC3, //11000011
	0xA5, //10100101
	0xA9, //10101001
	0xB2, //10110010
	0x54, //01010100
	0x44, //01000100
	0x48, //01001000
	0x30, //00110000
	
	//W 32
	0x43, //01000011
	0xA5, //10100101
	0xA5, //10100101
	0xB5, //10110101
	0xA9, //10101001
	0x82, //10000010
	0xB2, //10110010
	0xCC, //11001100
	
	//X 33
	0x67, //01100111
	0x59, //01011001
	0x52, //01010010
	0x44, //01000100
	0x22, //00100010
	0x4A, //01001010
	0x9A, //10011010
	0xE6, //11100110
	
	//Y 34
	0x46, //01000110
	0xAA, //10101010
	0x92, //10010010
	0x44, //01000100
	0x48, //01001000
	0x50, //01010000
	0x50, //01010000
	0x60, //01100000
	
	//Z 35
	0x3F, //00111111
	0x41, //01000001
	0x3A, //00111010
	0x14, //00010100
	0x28, //00101000
	0x4C, //01001100
	0x82, //10000010
	0xFC, //11111100
	
	//- 36
	0x00, //00000000
	0x00, //00000000
	0x3E, //00111110
	0x42, //01000010
	0x7C, //01111100
	0x00, //00000000
	0x00, //00000000
	0x00, //00000000
	
	//+ 37
	0x08, //00001000
	0x14, //00010100
	0x36, //00110110
	0x42, //01000010
	0x6C, //01101100
	0x28, //00101000
	0x10, //00010000
	0x00, //00000000
	
	//= 38
	0x00, //00000000
	0x3E, //00111110
	0x42, //01000010
	0x7C, //01111100
	0x84, //10000100
	0xF8, //11111000
	0x00, //00000000
	0x00, //00000000
	
	//_ 39
	0x00, //00000000
	0x00, //00000000
	0x00, //00000000
	0x00, //00000000
	0x00, //00000000
	0x7E, //01111110
	0x82, //10000010
	0xFC, //11111100
	
	//. 40
	0x00, //00000000
	0x00, //00000000
	0x00, //00000000
	0x00, //00000000
	0x38, //00111000
	0x48, //01001000
	0x48, //01001000
	0x70, //01110000
	
	//! 41
	0x0C, //00001100
	0x14, //00010100
	0x24, //00100100
	0x28, //00101000
	0x30, //00110000
	0x30, //00110000
	0x50, //01010000
	0x60, //01100000
	
	//? 42
	0x38, //00111000
	0x44, //01000100
	0x34, //00110100
	0x14, //00010100
	0x28, //00101000
	0x30, //00110000
	0x50, //01010000
	0x60, //01100000
	
	//# 43
	0x16, //00010110
	0x6A, //01101010
	0x81, //10000001
	0x5A, //01011010
	0x81, //10000001
	0x56, //01010110
	0x68, //01101000
	0x00, //00000000
	
	//(c) 44
	0x3C, //00111100
	0x42, //01000010
	0x9A, //10011010
	0xA2, //10100010
	0xA2, //10100010
	0xB2, //10110010
	0x84, //10000100
	0x78, //01111000
};

static unsigned char FontMask[] = {
	//0
	0xC3, //0x3C, //00111100
	0x81, //0x7E, //01111110
	0x01, //0xFE, //11111110
	0x11, //0xEE, //11101110
	0x11, //0xEE, //11101110
	0x01, //0xFE, //11111110
	0x03, //0xFC, //11111100
	0x87, //0x78, //01111000
	
	//1
	0xE3, //0x1C, //00011100
	0xC3, //0x3C, //00111100
	0x83, //0x7C, //01111100
	0xE3, //0x1C, //00011100
	0xE3, //0x1C, //00011100
	0xC1, //0x3E, //00111110
	0x81, //0x7E, //01111110
	0x83, //0x7C, //01111100
	
	//2
	0x87, //0x78, //01111000
	0x03, //0xFC, //11111100
	0x03, //0xFC, //11111100
	0x23, //0xDC, //11011100
	0xC3, //0x3C, //00111100
	0x81, //0x7E, //01111110
	0x01, //0xFE, //11111110
	0x03, //0xFC, //11111100
	
	//3
	0xC3, //0x3C, //00111100
	0x81, //0x7E, //01111110
	0xC1, //0x3E, //00111110
	0xC3, //0x3C, //00111100
	0xE1, //0x1E, //00011110
	0x81, //0x7E, //01111110
	0x03, //0xFE, //11111100
	0x87, //0x78, //01111000
	
	//4
	0xCB, //0x34, //00110100
	0xC1, //0x3E, //00111110
	0x81, //0x7E, //01111110
	0x81, //0x7E, //01111110
	0xC1, //0x3E, //00111110
	0xF1, //0x0E, //00001110
	0xF1, //0x0E, //00001110
	0xFB, //0x04, //00000100
	
	//5
	0xC3, //0x3C, //00111100
	0x81, //0x7E, //01111110
	0x83, //0x7C, //01111100
	0x81, //0x7E, //01111110
	0x81, //0x7E, //01111110
	0x81, //0x7E, //01111110
	0x03, //0xFC, //11111100
	0x87, //0x78, //01111000
	
	//6
	0xE3, //0x1C, //00011100
	0xC3, //0x3C, //00111100
	0x87, //0x78, //01111000
	0x87, //0x78, //01111000
	0x83, //0x7C, //01111100
	0x81, //0x7E, //01111110
	0x81, //0x7E, //01111110
	0xC3, //0x3C, //00111100
	
	//7
	0xC3, //0x3C, //00111100
	0x81, //0x7E, //01111110
	0x81, //0x7E, //01111110
	0xF1, //0x0E, //00001110
	0xE3, //0x1C, //00011100
	0xC7, //0x38, //00111000
	0x8F, //0x70, //01110000
	0x9F, //0x60, //01100000
	
	//8
	0xE3, //0x1C, //00011100
	0xC1, //0x3E, //00111110
	0xC1, //0x3E, //00111110
	0xC1, //0x3E, //00111110
	0x83, //0x7C, //01111100
	0x83, //0x7C, //01111100
	0x83, //0x7C, //01111100
	0xC7, //0x38, //00111000
	
	//9
	0xC7, //0x38, //00111000
	0x83, //0x7C, //01111100
	0x83, //0x7C, //01111100
	0x83, //0x7C, //01111100
	0xC3, //0x3C, //00111100
	0xC3, //0x3C, //00111100
	0x87, //0x78, //01111000
	0x8F, //0x70, //01110000
	
	//A
	0xf1, //0x0E, //00001110
	0xE1, //0x1E, //00011110
	0xE1, //0x1E, //00011110
	0xC0, //0x3F, //00111111
	0x80, //0x7F, //01111111
	0x80, //0x7F, //01111111
	0x08, //0xF7, //11110111
	0x19, //0xE6, //11100110
	
	//B
	0xC3, //0x3C, //00111100
	0xC1, //0x3E, //00111110
	0xC1, //0x3E, //00111110
	0x83, //0x7C, //01111100
	0x81, //0x7E, //01111110
	0x81, //0x7E, //01111110
	0x03, //0xFC, //11111100
	0x07, //0xF8, //11111000
	
	//C
	0xC3, //0x3C, //00111100
	0x81, //0x7E, //01111110
	0x81, //0x7E, //01111110
	0x0B, //0xF4, //11110100
	0x1F, //0xE0, //11100000
	0x03, //0xFC, //11111100
	0x81, //0x7F, //01111110
	0xC3, //0x3C, //00111100
	
	//D
	0xC3, //0x3C, //00111100
	0xC1, //0x3E, //00111110
	0xC0, //0x3F, //00111111
	0x88, //0x77, //01110111
	0x88, //0x77, //01110111
	0x81, //0x7E, //01111110
	0x03, //0xFC, //11111100
	0x07, //0xF8, //11111000
	
	//E
	0xC1, //0x3E, //00111110
	0xC0, //0x3F, //00111111
	0xC0, //0x2F, //00111111
	0x81, //0x7E, //01111110
	0x87, //0x78, //01111000
	0x83, //0x7C, //01111100
	0x01, //0xFE, //11111110
	0x03, //0xFC, //11111100
	
	//F
	0xC1, //0x3E, //00111110
	0xC0, //0x3F, //00111111
	0xC0, //0x3F, //00111111
	0x98, //0x73, //01110011
	0x87, //0x78, //01111000
	0x87, //0x78, //01111000
	0x1F, //0xE0, //11100000
	0x7F, //0xE0, //11100000
	
	//G
	0xC3, //0x3C, //00111100
	0x81, //0x7E, //01111110
	0x81, //0x7E, //01111110
	0x1F, //0xE0, //11100000
	0x13, //0xEC, //11101100
	0x01, //0xFE, //11111110
	0x81, //0x7E, //01111110
	0x71, //0x3E, //00111110
	
	//H
	0x99, //0x66, //01100110
	0x88, //0x77, //01110111
	0x88, //0x77, //01110111
	0x00, //0xFF, //11111111
	0x01, //0xFE, //11111110
	0x01, //0xFE, //11111110
	0x11, //0xEE, //11101110
	0x33, //0xCC, //11001100
	
	//I
	0x80, //0x7F, //01111111
	0x00, //0xFF, //11111111
	0x01, //0xFE, //11111110
	0xE3, //0x1C, //00011100
	0xE3, //0x1C, //00011100
	0x80, //0x7F, //01111111
	0x00, //0xFF, //11111111
	0x01, //0xFE, //11111110
	
	//J
	0x70, //0x7F, //01111111
	0x00, //0xFF, //11111111
	0x00, //0xFF, //11111111
	0xE3, //0x1C, //00011100
	0x23, //0xDC, //11011100
	0x03, //0xFC, //11111100
	0x07, //0xF8, //11111000
	0x8F, //0x70, //01110000
	
	//K
	0x9C, //0x63, //01100011
	0x10, //0xEF, //11101111
	0x01, //0xFE, //11111110
	0x03, //0xFC, //11111100
	0x07, //0xF8, //11111000
	0x03, //0xFC, //11111100
	0x01, //0xFE, //11111110
	0x31, //0xCE, //11001110
	
	//L
	0xCF, //0x30, //00110000
	0x8F, //0x70, //01110000
	0x8F, //0x70, //01110000
	0x8F, //0x70, //01110000
	0x1F, //0xE0, //11100000
	0x03, //0xFC, //11111100
	0x01, //0xFE, //11111110
	0x01, //0xFE, //11111110
	
	//M
	0xCC, //0x33, //00110011
	0x80, //0x7F, //01111111
	0x80, //0x7F, //01111111
	0x80, //0x7F, //01111111
	0x00, //0xFF, //11111111
	0x00, //0xFF, //11111111
	0x18, //0xE7, //11100111
	0x39, //0xC6, //11000110
	
	//N
	0xDC, //0x23, //00100011
	0x88, //0x77, //01110111
	0x80, //0x7F, //01111111
	0x80, //0x7F, //01111111
	0x00, //0xFF, //11111111
	0x11, //0xEE, //11101110
	0x11, //0xEE, //11101110
	0x3B, //0xC4, //11000100
	
	//O
	0xC7, //0x38, //00111000
	0x83, //0x7C, //01111100
	0x81, //0x7E, //01111110
	0x11, //0xEE, //11101110
	0x11, //0xEE, //11101110
	0x03, //0xFC, //11111100
	0x83, //0x7C, //01111100
	0xC7, //0x38, //00111000
	
	//P
	0xC3, //0x3C, //00111100
	0x81, //0x7E, //01111110
	0x81, //0x7E, //01111110
	0x83, //0x7C, //01111100
	0x07, //0xF8, //11111000
	0x1F, //0xE0, //11100000
	0x1F, //0xE0, //11100000
	0x3F, //0xC0, //11000000
	
	//Q
	0xC7, //0x38, //00111000
	0x83, //0x7C, //01111100
	0x01, //0xFE, //11111110
	0x11, //0xEE, //11101110
	0x11, //0xEE, //11101110
	0x01, //0xFE, //11111110
	0x80, //0x7F, //01111111
	0xC0, //0x3F, //00111111
	
	//R
	0xC1, //0x3E, //00111110
	0x80, //0x7F, //01111111
	0x80, //0x7F, //01111111
	0x81, //0x7E, //01111110
	0x01, //0xFE, //11111110
	0x10, //0xEF, //11101111
	0x18, //0xE7, //11100111
	0x3C, //0xC3, //11000011
	
	//S
	0xC1, //0x3E, //00111110
	0x80, //0x7F, //01111111
	0x81, //0x7E, //01111110
	0x83, //0x7C, //01111100
	0xC1, //0x3E, //00111110
	0x81, //0x7E, //01111110
	0x01, //0xFE, //11111110
	0x83, //0x7C, //01111100
	
	//T
	0x80, //0x7F, //01111111
	0x00, //0xFF, //11111111
	0x00, //0xFF, //11111111
	0xE3, //0x1C, //00011100
	0xE3, //0x1C, //00011100
	0xC7, //0x38, //00111000
	0xC7, //0x38, //00111000
	0xCF, //0x30, //00110000
	
	//U
	0x9D, //0x62, //01100010
	0x18, //0xE7, //11100111
	0x18, //0xE7, //11100111
	0x18, //0xE7, //11100111
	0x10, //0xEF, //11101111
	0x01, //0xFE, //11111110
	0x81, //0x7E, //01111110
	0xC3, //0x3C, //00111100
	
	//V
	0x3C, //0xC3, //11000011
	0x18, //0xE7, //11100111
	0x10, //0xEF, //11101111
	0x01, //0xFE, //11111110
	0x83, //0x7C, //01111100
	0x83, //0x7C, //01111100
	0x87, //0x78, //01111000
	0xCF, //0x30, //00110000
	
	//W
	0xBC, //0x43, //01000011
	0x18, //0x7E, //11100111
	0x18, //0x7E, //11100111
	0x08, //0xF7, //11110111
	0x00, //0xFF, //11111111
	0x01, //0xFE, //11111110
	0x01, //0xFE, //11111110
	0x33, //0xCC, //11001100
	
	//X
	0x98, //0x67, //01100111
	0x80, //0x7F, //01111111
	0x81, //0x7E, //01111110
	0x83, //0x7C, //01111100
	0xC1, //0x3E, //00111110
	0x81, //0x7E, //01111110
	0x01, //0xFE, //11111110
	0x19, //0xE6, //11100110
	
	//Y
	0xB9, //0x46, //01000110
	0x11, //0xEE, //11101110
	0x01, //0xFC, //11111110
	0x83, //0x7C, //01111100
	0x87, //0x78, //01111000
	0x8F, //0x70, //01110000
	0x8F, //0x70, //01110000
	0x9F, //0x60, //01100000
	
	//Z
	0xC0, //0x3F, //00111111
	0x80, //0x7F, //01111111
	0xC1, //0x3E, //00111110
	0xE3, //0x1C, //00011100
	0xC7, //0x38, //00111000
	0x83, //0x7C, //01111100
	0x01, //0xFE, //11111110
	0x03, //0xFC, //11111100
	
	//-
	0xFF, //0x00, //00000000
	0xFF, //0x00, //00000000
	0xC1, //0x3E, //00111110
	0x81, //0x7E, //01111110
	0x8C, //0x7C, //01111100
	0xFF, //0x00, //00000000
	0xFF, //0x00, //00000000
	0xFF, //0x00, //00000000
	
	//+
	0xF7, //0x08, //00001000
	0xE3, //0x1C, //00011100
	0xC1, //0x3E, //00111110
	0x81, //0x7E, //01111110
	0x83, //0x7C, //01111100
	0xC7, //0x38, //00111000
	0xEF, //0x10, //00010000
	0xFF, //0x00, //00000000
	
	//=
	0xFF, //0x00, //00000000
	0xC1, //0x3E, //00111110
	0x81, //0x7E, //01111110
	0x83, //0x7C, //01111100
	0x03, //0xFC, //11111100
	0x07, //0xF8, //11111000
	0xFF, //0x00, //00000000
	0xFF, //0x00, //00000000
	
	//_
	0xFF, //0x00, //00000000
	0xFF, //0x00, //00000000
	0xFF, //0x00, //00000000
	0xFF, //0x00, //00000000
	0xFF, //0x00, //00000000
	0x81, //0x7E, //01111110
	0x01, //0xFE, //11111110
	0x03, //0xFC, //11111100
	
	//.
	0xFF, //0x00, //00000000
	0xFF, //0x00, //00000000
	0xFF, //0x00, //00000000
	0xFF, //0x00, //00000000
	0xC7, //0x38, //00111000
	0x87, //0x78, //01111000
	0x87, //0x78, //01111000
	0x8F, //0x70, //01110000
	
	//!
	0xF3, //0x0C, //00001100
	0xE3, //0x1C, //00011100
	0xC3, //0x3C, //00111100
	0xC7, //0x38, //00111000
	0xCF, //0x30, //00110000
	0xCF, //0x30, //00110000
	0x8F, //0x70, //01110000
	0x9F, //0x60, //01100000
	
	//?
	0xC7, //0x38, //00111000
	0x83, //0x7C, //01111100
	0xC3, //0x3C, //00111100
	0xE3, //0x1C, //00011100
	0xC7, //0x38, //00111000
	0xCF, //0x30, //00110000
	0x8F, //0x70, //01110000
	0x9F, //0x60, //01100000
	
	//#
	0xE9, //0x16, //00010110
	0x81, //0x7E, //01111110
	0x00, //0xFF, //11111111
	0x81, //0x7E, //01111110
	0x00, //0xFF, //11111111
	0x81, //0x7E, //01111110
	0x97, //0x68, //01101000
	0xFF, //0x00, //00000000
	
	//(c)
	0xC3, //0x3C, //00111100
	0xBD, //0x42, //01000010
	0x65, //0x9A, //10011010
	0x5D, //0xA2, //10100010
	0x5D, //0xA2, //10100010
	0x4D, //0xB2, //10110010
	0x7B, //0x84, //10000100
	0x87, //0x78, //01111000
};

/*static unsigned short Infinity[] = {
	0x381C, //0011100000011100
	0x4662, //0100011001100010
	0x9999, //1001100110011001
	0xA425, //1010010000100101
	0xA665, //1010011001100101
	0x9999, //1001100110011001
	0x4662, //0100011001100010
	0x381C, //0011100000011100
};*/

static unsigned char Mouse[] = {
	/*0x80, //1000000-
		0xE0, //1110000-
		0xF8, //1111100-
		0x7C, //0111110-
		0x78, //0111100-
		0x2C, //0010110-
		0x06, //0000011-*/
	0x70, //0111000-
	0x88, //1000100-
	0x88, //1000100-
	0x98, //1001100-
	0x7C, //0111110-
	0x1E, //0001111-
	0x1C, //0001110-
	0x06, //0000011-
};

#endif
