// C Source File
// Created 12/26/2002; 10:02:46 PM

/*****************************************************
*
*                     Includes
*
*****************************************************/

#include <stdlib.h>
#include <gray.h>
#include <sprites.h>
#include <kbd.h>
#include <graph.h>
#include <system.h>
#include <mem.h>
#include <peekpoke.h>
#include <intr.h>
#include "Intro.h"
#include "Snake.h"
#include "extgraph.h"

/*****************************************************
*
*                 Global variables
*
*****************************************************/

static unsigned char *backbuffer, *backbuffer2; // Used for fire


/*****************************************************
*
*                    Functions
*
*****************************************************/


/************************************************
*
*  copyScr() - Copies a rectangle from one
*             plane to another
*
*  void *to  -  The destination plane (240x128)
*  void *from - The source plane (240x128)
*  int x0   -   The x coord of the upper left corner
*                (must be a multiple of 8)
*  int y0   -   The y coord of the upper left corner
*  int x1   -   The x coord of the lower right corner
*                (must be a multiple of 8)
*  int y1   -   The y coord of the lower right corner
*
************************************************/

void copyScr(void *to, void *from, int x0, int y0, int x1, int y1) { //light gray plane, buffer, 32, 40, 128, 59
	register void *ptr1 = to + 30*y0 + (x0>>3), *ptr2 = from + 30*y0 + (x0>>3); //to + 1204, from + 1204
	register int i, diff = (x1>>3)-(x0>>3);
	while(ptr1 <= to + 30*y1 + (x1>>3)) { //ptr1 must be less than end pixel byte, (from +) 1786
		for(i = 0; i < diff/4; i++, ptr1 += 4, ptr2 += 4) //keep 'i' under x-coord(byte) difference / 4, 3; each time add 1 to 'i', and 4 (long-word) to the ptrs
			poke_l(ptr1, peek_l(ptr2)); //replace long-word at ptr1 with long-word at ptr2. (copy data)
		ptr1 += 30 - diff; //add to make ptrs only copy starting from the first x-coord
		ptr2 += 30 - diff;
	}
}


/************************************************
*
*  FirewreathLogo() - Displays the Firewreath Software
*                    logo animation
*
************************************************/

void FirewreathLogo(void) {
	int i, frame = 0, frmchg = 1;//, x, y;
	
	//ClrScr();
	flameWipe();
	
	for(i = 1; i <= 8; i++) {
		//scroll_right(GetPlane(DARK_PLANE));
		//scroll_right(GetPlane(LIGHT_PLANE));
		
		//Sprite16(i*2, 43, 14, fly_dragon+(frame*28), GetPlane(DARK_PLANE), SPRT_XOR);
		//Sprite16(i*2, 43, 14, fly_dragon+(frame*28)+14, GetPlane(LIGHT_PLANE), SPRT_XOR);
		GraySprite16_XOR(i*2, 43, 14, fly_dragon+(frame*28), fly_dragon+(frame*28)+14, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE));
		//optDelay(1000);
		optDelay(75);
		//Sprite16(i*2, 43, 14, fly_dragon+(frame*28), GetPlane(DARK_PLANE), SPRT_XOR);
		//Sprite16(i*2, 43, 14, fly_dragon+(frame*28)+14, GetPlane(LIGHT_PLANE), SPRT_XOR);
		GraySprite16_XOR(i*2, 43, 14, fly_dragon+(frame*28), fly_dragon+(frame*28)+14, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE));
		frame += frmchg;
		if(frame != 1) frmchg = 0 - frmchg;
	}
	
	//optDelay(50);
	optDelay(5);
	//Sprite16(16, 43, 14, dragon, GetPlane(DARK_PLANE), SPRT_XOR);
	//Sprite16(16, 43, 14, dragon+14, GetPlane(LIGHT_PLANE), SPRT_XOR);
	GraySprite16_XOR(16, 43, 14, dragon, dragon+14, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE));
	//optDelay(2500);
	optDelay(200);
	//Sprite16(16, 43, 14, dragon, GetPlane(DARK_PLANE), SPRT_XOR);
	//Sprite16(16, 43, 14, dragon+14, GetPlane(LIGHT_PLANE), SPRT_XOR);
	GraySprite16_XOR(16, 43, 14, dragon, dragon+14, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE));
	//Sprite16(16, 43, 14, dragon+28, GetPlane(DARK_PLANE), SPRT_XOR);
	//Sprite16(16, 43, 14, dragon+42, GetPlane(LIGHT_PLANE), SPRT_XOR);
	GraySprite16_XOR(16, 43, 14, dragon+28, dragon+42, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE));
	//optDelay(5000);
	optDelay(400);
	
	//Sprite16(16, 43, 14, dragon+28, GetPlane(DARK_PLANE), SPRT_XOR);
	//Sprite16(16, 43, 14, dragon+42, GetPlane(LIGHT_PLANE), SPRT_XOR);
	GraySprite16_XOR(16, 43, 14, dragon+28, dragon+42, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE));
	//Sprite16(16, 43, 14, dragon, GetPlane(DARK_PLANE), SPRT_XOR);
	//Sprite16(16, 43, 14, dragon+14, GetPlane(LIGHT_PLANE), SPRT_XOR);
	GraySprite16_XOR(16, 43, 14, dragon, dragon+14, GetPlane(DARK_PLANE), GetPlane(LIGHT_PLANE));
	
	fire(32, 40, 128, 59, 20, FIRE_DARK);//GetPlane(DARK_PLANE));
	
	//Sprite32(32, 43, 14, logo, GetPlane(DARK_PLANE), SPRT_XOR);
	Sprite32_XOR(32, 43, 14, logo, GetPlane(LIGHT_PLANE));
	//Sprite32(64, 43, 14, logo+14, GetPlane(DARK_PLANE), SPRT_XOR);
	Sprite32_XOR(64, 43, 14, logo+14, GetPlane(LIGHT_PLANE));
	//Sprite32(96, 43, 14, logo+28, GetPlane(DARK_PLANE), SPRT_XOR);
	Sprite32_XOR(96, 43, 14, logo+28, GetPlane(LIGHT_PLANE));
	
	/*Sprite32(48, 61, 7, logo+42, GetPlane(DARK_PLANE), SPRT_XOR);
	Sprite32(80, 61, 7, logo+49, GetPlane(DARK_PLANE), SPRT_XOR);
	Sprite32(48, 61, 7, logo+56, GetPlane(LIGHT_PLANE), SPRT_XOR);
	Sprite32(80, 61, 7, logo+63, GetPlane(LIGHT_PLANE), SPRT_XOR);*/
	
	dissolve();
	fire(32, 40, 128, 59, -1, FIRE_DARK);//GetPlane(DARK_PLANE));
	if(backbuffer)
		free(backbuffer);
	if(backbuffer2)
		free(backbuffer2);
}


/************************************************
*
*  fire() - Creates a fire-like animation
*
*  int x0   -   The x coord of the upper left corner
*                (must be a multiple of 8)
*  int y0   -   The y coord of the upper left corner
*  int x1   -  The x coord of the lower right corner
*                (must be a multiple of 8)
*  int y1   -   The y coord of the lower right corner
*  int end   -  The desired frames of animation
*             (-1 means wait for keypress to stop)
*  int color  -   The color of the fire
*  //void *dest - The plane to draw fire on
*
************************************************/

void fire(int x0, int y0, int x1, int y1, int end, int color) {
	unsigned char /**backbuffer,*/ *p1 = backbuffer;
	int i, value, count = 0;
	//void *kbq;
	//short key;
	
	//kbq = kbd_queue();
	
	if(backbuffer == NULL && color & FIRE_LIGHT) {
		backbuffer = (unsigned char*)malloc(30*128);
		memset(backbuffer,0,128*30);
		copyScr(backbuffer, GetPlane(LIGHT_PLANE), x0, y0, x1, y1);
	}
	if(backbuffer2 == NULL && color & FIRE_DARK) {
		backbuffer2 = (unsigned char*)malloc(30*128);
		memset(backbuffer2,0,128*30);
		copyScr(backbuffer2, GetPlane(DARK_PLANE), x0, y0, x1, y1);
	}
	
	do {
		if(color & FIRE_LIGHT) {
			for (i = (x0>>3); i < (x1>>3); i++)
				*(backbuffer + y1*30 + i) = (unsigned char)0xff;
			
			//scrollUp(backbuffer);
			ScrollUp240((unsigned short*)backbuffer, 100);
			
			for (p1 = backbuffer + (y0+4)*30 + (x0>>3); p1 < backbuffer + (y1-4)*30; p1++) {
				value = random(700);
				if (value < 255) *p1 &= (unsigned char)value;
			}
			
			copyScr(GetPlane(LIGHT_PLANE), backbuffer, x0, y0, x1, y1);
		}
		if(color & FIRE_DARK) {
			for (i = (x0>>3); i < (x1>>3); i++)
				*(backbuffer2 + y1*30 + i) = (unsigned char)0xff;
			
			//scrollUp(backbuffer);
			ScrollUp240((unsigned short*)backbuffer2, 100);
			
			for (p1 = backbuffer2 + (y0+4)*30 + (x0>>3); p1 < backbuffer2 + (y1-4)*30; p1++) {
				value = random(700);
				if (value < 255) *p1 &= (unsigned char)value;
			}
			
			copyScr(GetPlane(DARK_PLANE), backbuffer2, x0, y0, x1, y1);
		}
		
		if(end != -1) count++;
		if(count == end) break;
		
	} while(!getKey());//OSdequeue(&key, kbq));
	
	//free(backbuffer);
}


/************************************************
*
*  dissolve() - Uses a dissolve effect to display
*                the "Software" graphic
*
************************************************/

void dissolve(void) {
	int tmpoffx = 48, tmpoffy = 61, x, y, byteoffset;
	unsigned char *p1=GetPlane(DARK_PLANE), *p2=GetPlane(LIGHT_PLANE);
	unsigned char pixmask;
	unsigned int seq = 1;
	unsigned long is_set1 = 0, is_set2 = 0;
	int i = 0;

	do {
		x = seq & 0x3f;
		y = seq >> 6;
		
		if (y<7) {
			if (x<32) {
				is_set1 = logo[y+42] & (0x80000000 >> x);
				is_set2 = logo[y+56] & (0x80000000 >> x);
			}
			else {
				is_set1 = logo[y+49] & (0x80000000 >> (x-32));
				is_set2 = logo[y+63] & (0x80000000 >> (x-32));
			}
		}
		
		x += tmpoffx;
		y += tmpoffy;
		
		byteoffset = y * 30 + (x >> 3);
		pixmask = 0x80 >> (x & 0x07);
		
		if (y>=tmpoffy && y<tmpoffy+7) {
			if (is_set1) *(p1+byteoffset) |= pixmask;
			if (is_set2) *(p2+byteoffset) |= pixmask;
		}
		
		if (seq & 1) seq = (seq>>1)^0x0110;
		else seq >>= 1;
		
		if(++i > 10) {
			fire(32, 40, 128, 59, 1, FIRE_DARK);//GetPlane(DARK_PLANE));
			i = 0;
		}
		
	} while (seq != 1);
}

/************************************************
*
*  flameWipe() - Clears the screen using a fire
*                 effect that covers the screen
*
************************************************/

void flameWipe(void) {
	fire(0, 79, 160, 99, 20, FIRE_BOTH);//GetPlane(DARK_PLANE));
	int i = 99;
	for(; i >= 21; i -= 3) {
		FastDrawGrayHLine(0, 160, i+3, COLOR_WHITE);
		FastDrawGrayHLine(0, 160, i+2, COLOR_WHITE);
		FastDrawGrayHLine(0, 160, i+1, COLOR_WHITE);
		ScrollUp240((unsigned short*)backbuffer, 100);
		ScrollUp240((unsigned short*)backbuffer, 100);
		ScrollUp240((unsigned short*)backbuffer, 100);
		ScrollUp240((unsigned short*)backbuffer2, 100);
		ScrollUp240((unsigned short*)backbuffer2, 100);
		ScrollUp240((unsigned short*)backbuffer2, 100);
		fire(0, i-21, 160, i, 1, FIRE_BOTH);//GetPlane(DARK_PLANE));
		if(getKey()) {
			ClearGrayScreen();
			return;
		}
	}
	for(; i > 0; i -= 3) {
		FastDrawGrayHLine(0, 160, i+3, COLOR_WHITE);
		FastDrawGrayHLine(0, 160, i+2, COLOR_WHITE);
		FastDrawGrayHLine(0, 160, i+1, COLOR_WHITE);
		ScrollUp240((unsigned short*)backbuffer, 100);
		ScrollUp240((unsigned short*)backbuffer, 100);
		ScrollUp240((unsigned short*)backbuffer, 100);
		ScrollUp240((unsigned short*)backbuffer2, 100);
		ScrollUp240((unsigned short*)backbuffer2, 100);
		ScrollUp240((unsigned short*)backbuffer2, 100);
		fire(0, 0, 160, i, 1, FIRE_BOTH);//GetPlane(DARK_PLANE));
		if(getKey()) {
			ClearGrayScreen();
			return;
		}
	}
	FastDrawGrayHLine(0, 160, 3, COLOR_WHITE);
	FastDrawGrayHLine(0, 160, 2, COLOR_WHITE);
	FastDrawGrayHLine(0, 160, 1, COLOR_WHITE);
	FastDrawGrayHLine(0, 160, 0, COLOR_WHITE);
}