// C Header File
// Created 9/3/2002; 5:29:33 PM

#ifndef SNAKE_H
#define SNAKE_H

/////////////////////////
// CONSTANT MACROS
/////////////////////////
#define DELAY_SECOND 300//350

#define ROW_ARROW          ~0x01
#define ROW_MODIFIER       ~0x01
#define ROW_ENTER          ~0x02
#define ROW_ESC            ~0x40
#define ROW_BOSS           ~0x02
#define ROW_MINUSPLUS      ~0x02
#define ROW_F1             ~0x20
#define ROW_F5             ~0x02

#define COL_LEFT            0x02
#define COL_RIGHT           0x08
#define COL_DOWN            0x04
#define COL_UP              0x01
#define COL_ENTER           0x01
#define COL_ESC             0x01
#define COL_2ND             0x10
#define COL_DMND            0x40
#define COL_BOSS            0x40
#define COL_MINUS           0x04
#define COL_PLUS            0x02
#define COL_FUNC            0x80

#define KEY_NONE            0x0000
#define KEY_LEFT            0x0001
#define KEY_RIGHT           0x0002
#define KEY_DOWN            0x0004
#define KEY_UP              0x0008
#define KEY_ENTER           0x0010
#define KEY_ESC             0x0020
#define KEY_2ND             0x0040
#define KEY_DMND            0x0080
#define KEY_BOSS            0x0100
#define KEY_MINUS           0x0200
#define KEY_PLUS            0x0400
#define KEY_F1              0x0800
#define KEY_F5              0x1000

#define OSKEY_DOWN          340
#define OSKEY_DOWNLEFT      342
#define OSKEY_LEFT          338
#define OSKEY_UP            337
#define OSKEY_UPRIGHT       345
#define OSKEY_RIGHT         344
#define OSKEY_SHIFT         8192U
#define OSKEY_DIAMOND       16384U
#define OSKEY_BACKSPACE     257
#define OSKEY_ENTER         13
#define OSKEY_ESC           264
#define OSKEY_MINARROW      337
#define OSKEY_MAXARROW      345
#define OSKEY_CASEDIFF      32
#define OSKEY_SPACE         32

#define ROW_EU             ~0x02
#define ROW_T_             ~0x04
#define ROW_ZW             ~0x08
#define ROW_YV             ~0x10
#define ROW_XP             ~0x20
/*
#define COL_A               0x10
#define COL_B               0x08
#define COL_C               0x04
#define COL_D               0x02
#define COL_E               0x01
#define COL_F               0x10
#define COL_G               0x08
#define COL_H               0x04
#define COL_I               0x02
#define COL_J               0x01
#define COL_K               0x10
#define COL_L               0x08
#define COL_M               0x04
#define COL_N               0x02
#define COL_O               0x01
#define COL_P               0x10
#define COL_Q               0x08
#define COL_R               0x04
#define COL_S               0x02
#define COL_T               0x20
#define COL_U               0x01
#define COL_V               0x08
#define COL_W               0x04
#define COL_X               0x20
#define COL_Y               0x20
#define COL_Z               0x20
#define COL__               0x02
#define COL_BCK             0x40
#define COL_NTR             0x01
*/
#define COL_U               0x02  //ROW_EU
#define COL_O               0x04
#define COL_J               0x08
#define COL_E               0x10
#define COL__               0x01  //ROW_T_
#define COL_S               0x02
#define COL_N               0x04
#define COL_I               0x08
#define COL_D               0x10
#define COL_T               0x20
#define COL_W               0x01  //ROW_ZW
#define COL_R               0x02
#define COL_M               0x04
#define COL_H               0x08
#define COL_C               0x10
#define COL_Z               0x20
#define COL_V               0x01  //ROW_YV
#define COL_Q               0x02
#define COL_L               0x04
#define COL_G               0x08
#define COL_B               0x10
#define COL_Y               0x20
#define COL_P               0x02  //ROW_XP
#define COL_K               0x04
#define COL_F               0x08
#define COL_A               0x10
#define COL_X               0x20
#define COL_BCK             0x40  //ROW_T_
#define COL_NTR             0x01  //ROW_EU

#define KEY_A               0x00000001
#define KEY_B               0x00000002
#define KEY_C               0x00000004
#define KEY_D               0x00000008
#define KEY_E               0x00000010
#define KEY_F               0x00000020
#define KEY_G               0x00000040
#define KEY_H               0x00000080
#define KEY_I               0x00000100
#define KEY_J               0x00000200
#define KEY_K               0x00000400
#define KEY_L               0x00000800
#define KEY_M               0x00001000
#define KEY_N               0x00002000
#define KEY_O               0x00004000
#define KEY_P               0x00008000
#define KEY_Q               0x00010000
#define KEY_R               0x00020000
#define KEY_S               0x00040000
#define KEY_T               0x00080000
#define KEY_U               0x00100000
#define KEY_V               0x00200000
#define KEY_W               0x00400000
#define KEY_X               0x00800000
#define KEY_Y               0x01000000
#define KEY_Z               0x02000000
#define KEY__               0x04000000
#define KEY_BCK             0x08000000
#define KEY_NTR             0x10000000
#define KEY_OTHER           0x20000000

#define NOT_A_DIR          -1
#define DIR_SOUTH           0
#define DIR_WEST            1
#define DIR_NORTH           2
#define DIR_EAST            3

#define BOARD_EMPTY         0
#define BOARD_APPLE         1
#define BOARD_OBSTACLE      2
#define BOARD_SNAKE         4

#define BOARD_TO_MAX_X      0
#define BOARD_TO_MAX_Y      1
#define BOARD_TO_MIN_APPLES 2
#define BOARD_TO_MAX_APPLES 3
#define BOARD_TO_WRAP       4
#define BOARD_TO_DATA       5

#define STATUS_ALIVE        0
#define DEATH_OUT_OF_BOUNDS 1
#define DEATH_OBSTACLE      2
#define DEATH_SNAKE         4
#define DEATH_ESC           5
#define STATUS_NEXT_LEVEL   6

#define NO_LEVEL           -4
#define RANDOM_LEVEL       -3
#define CUSTOM_LEVEL       -2
#define LEVEL_FREEPLAY     -1
#define LEVEL_0             0
#define LEVEL_1             1
#define LEVEL_2             2
#define LEVEL_3             3
#define LEVEL_4             4
#define LEVEL_5             5
#define LEVEL_6             6
#define LEVEL_7             7
#define LEVEL_8             8
#define LEVEL_9             9

#define DEFAULT_WIDTH       30
#define DEFAULT_HEIGHT      15

#define MENU_FREEPLAY       0
#define MENU_LEVELS         1
#define MENU_LEVELEDITOR    2
#define MENU_OPTIONS        3
#define MENU_ABOUT          4
#define MENU_QUIT           5

#define SUBMENU_NONE        0
#define SUBMENU_LEVELSTART  1
#define SUBMENU_LEVELWARP   2
#define SUBMENU_LEVEDITNEW  1
#define SUBMENU_LEVEDITLOAD 2
#define SUBMENU_LEVEDITPLAY 3
#define SUBMENU_LEVEDITRAND 4

#define FOCUS_TOP_MENU      0
#define FOCUS_SUB_MENU      1

#define SPEED_SLOWEST       0
#define SPEED_EXTREMELYSLOW 1
#define SPEED_VERYSLOW      2
#define SPEED_SLOW          3
#define SPEED_MEDIUM        4
#define SPEED_FAST          5
#define SPEED_VERYFAST      6
#define SPEED_EXTREMELYFAST 7
#define SPEED_FASTEST       8

#define GAME_RANDOM        -2
#define GAME_CUSTOM        -1
#define GAME_FREEPLAY       0
#define GAME_LEVELS         1
#define GAME_WARP           2

#define TEXT_COLOR          0x0007
#define TEXT_WHITE          0x0000
#define TEXT_LIGHT          0x0001
#define TEXT_DARK           0x0002
#define TEXT_BLACK          0x0003
#define TEXT_NORMAL         0x0004
#define TEXT_INTERIOR       0x0078
#define TEXT_GRAYINTERIOR   0x0038
#define TEXT_INTWHITE       0x0008
#define TEXT_INTLIGHT       0x0010
#define TEXT_INTDARK        0x0020
#define TEXT_INTMASKNORMAL  0x0040
#define TEXT_METHOD         0x0380
#define TEXT_XOR            0x0080
#define TEXT_MASK           0x0100
#define TEXT_OR             0x0200
#define TEXT_ASSUREOUTLINE  0x0400

#define ISPRITE_XOR         1
#define ISPRITE_OR          2
#define ISPRITE_AND         4

#define EDITOR_NEW          0
#define EDITOR_LOAD         1

#define SAVE_INVALIDNAME   -1
#define SAVE_FAILED         0
#define SAVE_SUCCESS        1
#define SAVE_ESCKEY         2

#define FIRE_LIGHT          0x01
#define FIRE_DARK           0x02
#define FIRE_BOTH           0x03

#define OBST_SOUTH          0x8
#define OBST_WEST           0x4
#define OBST_NORTH          0x2
#define OBST_EAST           0x1

#define HELP_MENU           1
#define HELP_GAME           2
#define HELP_EDITOR         3

/////////////////////////
// FUNCTION / VARIABLE MACROS
//////////////////////////////
#define BOARDWIDTH (*(board + BOARD_TO_MAX_X))
#define BOARDHEIGHT (*(board + BOARD_TO_MAX_Y))
#define BOARDMINAPPLES (*(board + BOARD_TO_MIN_APPLES))
#define BOARDMAXAPPLES (*(board + BOARD_TO_MAX_APPLES))
#define BOARDWRAP (*(board + BOARD_TO_WRAP))
#define BOARDPOS(x, y) (*(board + (x) + ((y) * BOARDWIDTH) + BOARD_TO_DATA))
#define MIDBOARD (((BOARDWIDTH-1)/2 + ((33 - BOARDWIDTH)/2)) * 5 - BOARDWIDTH%2 * 2)
#define BOTTOMBOARD (((BOARDHEIGHT-1) + (21 - BOARDHEIGHT)/2) * 5 - BOARDHEIGHT%2 * 2+2)
//#define MIDBOARD ((BOARDWIDTH-1)/2*5 + (80 - (BOARDWIDTH*5/2)))
//#define BOTTOMBOARD ((BOARDHEIGHT-1)*5 + (50 - (BOARDHEIGHT*5/2)))

/////////////////////////
// STRUCTURES
/////////////////////////
typedef struct _POS {
	int x, y;
} POS;

typedef struct _TURN {
	POS pos;
	int dir;
} TURN;

typedef struct _SCORE {
	//int level;
	char level[5];
	unsigned long score;
} SCORE;

typedef struct _SNAKE {
	POS head, tail;
	char headDir, lastDir, tailDir;
	char dead, lives, eating;
	int len, grow, turns;
	TURN *turn;
} SNAKE;


/////////////////////////
// FUNCTION PROTOTYPES
/////////////////////////

//Main routines
void delay(int);
void optDelay(int);
int contOptDelay(int);
int getKey(void);
int getAlpha(void);
void initSnake(SNAKE *);
SCORE game(int, int);
char* initBoard(int);
void forceExit(void);

//Graphics routines
void updateSnake(SNAKE *, char *);
void doIntro(void);
void drawHUD(SNAKE *);
void updateHUD(int, unsigned long);
void drawBoard(char *, int);
void doLevelIntro(int);
void doCustomIntro(char *);
void countdown(void);
void createApple(char *);
void drawDeath(char);
void winSequence(SNAKE *, char *, int);
void menu(void);
void options(int *);
void about(void);
void drawText(int, int, const char *, int);
void drawChar(int, int, char, int);
char pickChar(char);
void showPass(int);
int askWarp(void);
void drawHiscores(int);
int checkHiscores(SCORE, int);
int saveBoard(char *);
char* loadBoard(char *);
int askRandomDiff();
char* makeRandomBoard(int *);
void InvertedSprite8(int, int, int, unsigned char*, void *, int);
void openWindow(int, int);
void closeWindow(int, int);
void wipeScreen(void);
int getObstType(char *, int, int);

//Level Editor
void editor(int);
char* newEditBoard(void);
void getDimensions(int *, int *);

//File I/O Routines
int saveScores(SCORE *);
int loadScores(SCORE *);
int createScoreList(void);
int needScoreList(void);
int saveBoardFile(char *, char *);
char* loadBoardFile(char *);

//Intro Routines
void optDelay(int);
void copyScr(void *, void *, int, int, int, int);
void FirewreathLogo(void);
void fire(int, int, int, int, int, int);
void dissolve(void);
void flameWipe(void);

#endif
